#ifndef _FUSION_COMPILE_CONFIG_HPP_INCLUDED
#define _FUSION_COMPILE_CONFIG_HPP_INCLUDED


#define _FUSION_DEBUG true
#define FUS_IRRLICHT_SUPPORT

//#define
//const char* _FUSION_SEPARATOR_ = "==============";
////////////////////////////////////////////////////////////
// Define the SFML version
////////////////////////////////////////////////////////////
#define FUSION_VERSION_MAJOR 2
#define FUSION_VERSION_MINOR 0


////////////////////////////////////////////////////////////
// Identify the operating system
////////////////////////////////////////////////////////////
#if defined(_WIN32) || defined(__WIN32__)

    // Windows
    #define FUSION_SYSTEM_WINDOWS
    #ifndef NOMINMAX
        #define NOMINMAX
    #endif

#elif defined(linux) || defined(__linux)

    // Linux
    #define FUSION_SYSTEM_LINUX

#elif defined(__APPLE__) || defined(MACOSX) || defined(macintosh) || defined(Macintosh)

    // MacOS
    #define FUSION_SYSTEM_MACOS

#elif defined(__FreeBSD__) || defined(__FreeBSD_kernel__)

    // FreeBSD
    #define FUSION_SYSTEM_FREEBSD

#else

    // Unsupported system
    #error This operating system is not supported by Fusion library

#endif




////////////////////////////////////////////////////////////
// Define portable import / export macros
////////////////////////////////////////////////////////////
#if defined(FUSION_SYSTEM_WINDOWS) && !defined(FUSION_STATIC)

    #ifdef FUSION_EXPORTS

        // From DLL side, we must export
        #define FUSION_API __declspec(dllexport)

    #else

        // From client application side, we must import
        #define FUSION_API __declspec(dllimport)

    #endif

    // For Visual C++ compilers, we also need to turn off this annoying C4251 warning.
    // You can read lots ot different things about it, but the point is the code will
    // just work fine, and so the simplest way to get rid of this warning is to disable it
    #ifdef _MSC_VER

        #pragma warning(disable : 4251)

    #endif

#else

    // Other platforms and static build don't need these export macros
    #define FUSION_API

#endif





#endif
