#include "ITransformer.hpp"
#include <fusion/fusion.hpp>




//irr::scene::IAnimatedMeshSceneNode* node
ITransformer::ITransformer() :
    _animatedNode(0)
    , _callback(0)
//    , _transforming(false)
{
//irr::scene::IAnimatedMeshSceneNode*
    // load node only if precised
    //if(node)    load(node);
}


ITransformer::~ITransformer()
{

}


bool
ITransformer::isTransforming() const
{

    //_INFO << "End frame [" << _animatedNode->getEndFrame () << "] -- Current frame [" << _animatedNode->getFrameNr() << "]";
    //bool test=  (_animatedNode->getEndFrame () != _animatedNode->getFrameNr());
    return (f32)_animatedNode->getFrameNr() != _animatedNode->getEndFrame ();
//    return test;
    //return (_animatedNode->getEndFrame () != _animatedNode->getFrameNr()) ;
};


//const std::size_t& nbOfBoosters

void
ITransformer::load( irr::scene::IAnimatedMeshSceneNode* node)
{
    FUS_ASSERT(node);

    _animatedNode = node;
//    _transforming = false;


    _animatedNode->setLoopMode(false);
    //_animatedNode->setAnimationSpeed(3);
    //_animatedNode->setCurrentFrame(5);
    //_animatedNode->setFrameLoop(0,0);
    //_animatedNode->setDebugDataVisible(irr::scene::EDS_BBOX );
    //_animatedNode->setMaterialFlag(irr::video::EMF_SKE  ,true );

    //return true;
}



void
ITransformer::OnAnimationEnd(irr::scene::IAnimatedMeshSceneNode* node)
{


    if(_callback != nullptr)
    {
        _callback->OnAnimationEnd( node );
    }

//    _transforming = false;
    _animatedNode->setAnimationEndCallback( 0 );
//    _animatedNode->setAnimationEndCallback( 0 );
    //onTransformationEnd();
    //_INFO << "ITransformer : End of Transformation" ;
}




//
//
//void
//ITransformer::update(){
//    irr::scene::IBoneSceneNode* bone = _animatedNode->getJointNode(boneName);
//}


float
ITransformer::getTransformationAdvancement()
{

    irr::f32 transformationProgress = 1.f;


    if( isTransforming() )
    {

        // Pourcentage
        //getFrameNr returns current frame (f32)
        // getEndFrame() current end frame number (s32)
        // getStartFrame() Returns the current start frame number (s32).

        irr::f32 currentFrame = (f32)_animatedNode->getFrameNr ();
        // Ca devrait etre tjrs positif ?!
        irr::s32 animationNbOfFrames = core::abs_( _animatedNode->getEndFrame() - _animatedNode->getStartFrame() ) + 1;
        irr::f32 framesAlreadyDisplayed = core::abs_(currentFrame - _animatedNode->getStartFrame()) + 1;

//        // Selon la vitesse
//        if(_animatedNode->getAnimationSpeed () > 0)
//        {
////            framesAlreadyDisplayed = currentFrame - _animatedNode->getStartFrame() + 1;
//        }
//        else if(_animatedNode->getAnimationSpeed () < 0)
//        {
////            framesAlreadyDisplayed = _animatedNode->getEndFrame() - _animatedNode->getFrameNr () + 1;
//            framesAlreadyDisplayed = -framesAlreadyDisplayed;
//            //_animatedNode->getEndFrame() - _animatedNode->getFrameNr () + 1;
//        }

//        framesAlreadyDisplayed++;

        //_LOG_DEBUG << "framesAlreadyDisplayed" << framesAlreadyDisplayed;

//        transformationProgress   = (_animatedNode->getFrameNr () - _animatedNode->getStartFrame());
//        transformationProgress  /= ( _animatedNode->getStartFrame() - _animatedNode->getEndFrame() );
//        transformationProgress   = irr::core::abs_(transformationProgress );
        transformationProgress = framesAlreadyDisplayed/animationNbOfFrames;
    }

    return transformationProgress;
}





// 2 ieme version plus optimisee
// permet d'indiquer si on veut augmenter ou baisser le mode
// mais ne change pas le mode actuel !!!
// TODO renommer en targetFrame
bool
ITransformer::targetFrame(const int& targetedFrame)
{

    //irr::s32 endFrame = _animatedNode->getEndFrame ();
//    setAbsoluteAnimationSpeed(5);

    const int currentFrame = _animatedNode->getFrameNr();
    _animatedNode->setAnimationSpeed(5);


    if( _animatedNode->setFrameLoop(currentFrame,targetedFrame) )
    {

        _animatedNode->setAnimationEndCallback(this);
//        _transforming = true;
        return true;
    }
    else
    {
        _LOG_WARNING << "setFrameLoop returned false for animation" << currentFrame << " to " << targetedFrame;
        return false;
    }


}


