//#include "IWalkyrieMode.hpp"


#include "IWalkyrieMode.hpp"
#include <fusion/fusion.hpp>
#include <irrlicht.h>

using namespace irr;

IWalkyrieMode::IWalkyrieMode(const char* name) :
Range(0),
//TransitionDelay(0),
Frame(0)
, _previousMode(0)
, _nextMode(0)
, Name( name )
, DefaultAnimator(0)
{

    Speed.fill(0);
    AnimationSpeed = 0;
    YAngle = 0;
    ZAngle = 0;
}



void
IWalkyrieMode::printMode() const {

    _INFO << "Camera recul " << _cameraRecul;
    _INFO << "Range [" << getRange() << "]";
    _INFO << "Forward speed [" << getRange() << "]";
}

//
//IWalkyrieMode*
//IWalkyrieMode::operator=(const IWalkyrieMode* mode){
//
//    this->Range             = mode.Range;
//    this->Speed             = mode.Speed;
//    this->Frame             = mode.Frame;
//    this->_cameraRecul      = mode._cameraRecul;
//
//    return *this;
//}


//IWalkyrieMode
//IWalkyrieMode::interpolate(const float& progress,const IWalkyrieMode* start,const IWalkyrieMode* objective)
//{
//    //IWalkyrieMode temp;// = start;
//    return start.getInterpolated(progress,objective);
//    //return temp;
//}



void
IWalkyrieMode::interpolate(const IWalkyrieMode* start,const IWalkyrieMode* objective,const float& progress)
{
//TODO
    const float objectiveWeight = progress;
    const float startWeight      = 1.f  - progress;

    // interpolate speeds
//    std::for_each( std::begin(Speeds), std::end(Speeds), [startWaight,objectiveWeight,progress](it) { *it = core::lerp( ,progress); } )
    for(int i = 0; i< SpeedsCount; ++i){
    //BOOST_FOREACH()
        //std::for_each( Speed.begin)
        this->Speed[i] = core::lerp(start->Speed[i],objective->Speed[i], progress);
    }

    // Interpolate range
    this->Range = core::lerp( start->Range, objective->Range , progress);

    //this->processMoveFunction = this->processMoveFunction;
    // I think the irrlicht convention is weird
    // 2nd parameter at 1 => _cameraRecul = all 1
    //this->_cameraRecul,

    this->Frame = core::lerp( (f32)start->getFrame(), (f32)objective->getFrame(), progress);

/////////////////////////////////////////
    // non consistant with core::lerp
    /** \param a first vector to interpolate with, maximum at 1.0f
		\param b second vector to interpolate with, maximum at 0.0f
    **/
    _cameraRecul = _cameraRecul.interpolate(objective->getCameraRecul(),start->getCameraRecul(), progress );

}

//
//// TODO interpolate angles too (use a vector)
//IWalkyrieMode*
//IWalkyrieMode::interpolate(const float& progress,const IWalkyrieMode* objective)
//{
//
//    interpolate(progress,*this,objective);
////    float objectiveWeight = progress;
////    float startWeight      = 1.f  - progress;
////
////    // interpolate speeds
////    for(int i = 0; i< SpeedsCount; ++i){
////    //BOOST_FOREACH()
////        //std::for_each( Speed.begin)
////        this->Speed[i] = startWeight * this->Speed[i] + progress *objective.Speed[i];
////    }
////
////    // Interpolate range
////    this->Range = this->Range*startWeight + objectiveWeight * objective.Range;
////
////    //this->processMoveFunction = this->processMoveFunction;
////    // I think the irrlicht convention is weird
////    // 2nd parameter at 1 => _cameraRecul = all 1
////    //this->_cameraRecul,
////
/////////////////////////////////////////////
///////// TODO la y a un bug la camera bouge trop vite car on interpole pas la mm camera a chaque fois
//////////////////////////////////////////////
////    _cameraRecul = _cameraRecul.getInterpolated(objective._cameraRecul, startWeight );
////
////    setupSpeeds(const float& lateralSpeed,
////                const float& forwardSpeed,const float& defaultForward,
////                const float& backwardSpeed,const float& rollingSpeed,
////                const float& yawSpeed);
////    mode.setupAngleBounds();
//    return this;
//}
//



IWalkyrieMode*
IWalkyrieMode::setupSpeeds(
const float& lateralSpeed,
const float& forwardSpeed,
const float& defaultForward,
const float& backwardSpeed,
const float& rollingSpeed,
const float& yawSpeed
)
{


    Speed[Lateral]        = lateralSpeed;
    Speed[Forward]        = forwardSpeed;
    Speed[DefaultForward] = defaultForward;
    Speed[Backward]       = backwardSpeed;
    Speed[Roll]           = rollingSpeed;
    Speed[Yaw]            = yawSpeed;

    return (this);
}



IWalkyrieMode*
IWalkyrieMode::setAngleBounds(
const float& rollingLimit,
const float& yawLimit
)
{
    //
    YAngle = rollingLimit;
    ZAngle = yawLimit;
    return (this);
}


IWalkyrieMode*
IWalkyrieMode::setRange(const float& range)
{
    Range = range;
    return (this);
}

IWalkyrieMode*
IWalkyrieMode::defineAnimation(const int& noFrame,const irr::f32& animationSpeed)
{
    Frame           = noFrame;
    AnimationSpeed  = animationSpeed;
    return (this);
}


