#include "defs.hpp"
#include "CBindDescriptor.hpp"
#include <boost/assign/list_of.hpp>
#include <boost/assign/list_inserter.hpp>


using namespace irr;


/// Extern var
TTimeUnit QuickTapDelay = 200;





// TODO use initializer list
void
initializeKeycodes()
{

    // TODO http://www.boost.org/doc/libs/1_47_0/libs/bimap/example/bimap_and_boost/assign.cpp
    //SBimap<std::wstring,irr::EKEY_CODE> &keycodeBimap = keycodeBimap;
    TKeyCodeMap& keycodeBimap = CBindDescriptor::keycodeBimap;

//try {
    boost::assign::insert( keycodeBimap.Bimap.left )
        (KEY_LBUTTON,L"lbutton")
        (KEY_CANCEL,L"cancel")
        (KEY_MBUTTON,L"mbutton")
        (KEY_KEY_0,L"0")
        (KEY_KEY_1,L"1")
        (KEY_KEY_2,L"2")
        (KEY_KEY_3,L"3")
        (KEY_KEY_4,L"4")
        (KEY_KEY_5,L"5")
        (KEY_KEY_6,L"6")
        (KEY_KEY_7,L"7")
        (KEY_KEY_8,L"8")
        (KEY_KEY_9,L"9")
        (KEY_KEY_A,L"a")
        (KEY_KEY_B,L"b")
        (KEY_KEY_C,L"c")
        (KEY_KEY_D,L"d")
        (KEY_KEY_E,L"e")
        (KEY_KEY_F,L"f")
        (KEY_KEY_G,L"g")
        (KEY_KEY_H,L"h")
        (KEY_KEY_I,L"i")
        (KEY_KEY_J,L"j")
        (KEY_KEY_K,L"k")
        (KEY_KEY_L,L"l")
        (KEY_KEY_M,L"m")
        (KEY_KEY_N,L"n")
        (KEY_KEY_O,L"o")
        (KEY_KEY_P,L"p")
        (KEY_KEY_Q,L"q")
        (KEY_KEY_R,L"r")
        (KEY_KEY_S,L"s")
        (KEY_KEY_T,L"t")
        (KEY_KEY_U,L"u")
        (KEY_KEY_V,L"v")
        (KEY_KEY_W,L"w")
        (KEY_KEY_X,L"x")
        (KEY_KEY_Y,L"y")
        (KEY_KEY_Z,L"z")
//        (KEY_KEY_A,l"a")
//        (KEY_KEY_B,L"b")
//        (KEY_KEY_C,L"c")
//        (KEY_KEY_D,L"d")
//        (KEY_KEY_E,L"e")
//        (KEY_KEY_F,L"f")
//        (KEY_KEY_G,L"g")
//        (KEY_KEY_H,L"h")
//        (KEY_KEY_I,L"i")
//        (KEY_KEY_J,L"j")
//        (KEY_KEY_K,L"k")
//        (KEY_KEY_L,L"l")
//        (KEY_KEY_M,L"m")
//        (KEY_KEY_N,L"n")
//        (KEY_KEY_O,L"o")
//        (KEY_KEY_P,L"p")
//        (KEY_KEY_Q,L"q")
//        (KEY_KEY_R,L"r")
//        (KEY_KEY_S,L"s")
//        (KEY_KEY_T,L"t")
//        (KEY_KEY_U,L"u")
//        (KEY_KEY_V,L"v")
//        (KEY_KEY_W,L"w")
//        (KEY_KEY_X,L"x")
//        (KEY_KEY_Y,L"y")
//        (KEY_KEY_Z,L"z")
        (KEY_F1,L"f1")
        (KEY_F2,L"f2")
        (KEY_F3,L"f3")
        (KEY_F4,L"f4")
        (KEY_F5,L"f5")
        (KEY_F6,L"f6")
        (KEY_F7,L"f7")
        (KEY_F8,L"f8")
        (KEY_F9,L"f9")
        (KEY_F10,L"f10")
        (KEY_F11,L"f11")
        (KEY_F12,L"f12")
        (KEY_F13,L"f13")
        (KEY_F14,L"f14")
        (KEY_F15,L"f15")
        (KEY_F16,L"f16")
        (KEY_F17,L"f17")
        (KEY_F18,L"f18")
        (KEY_F19,L"f19")
        (KEY_F20,L"f20")
        (KEY_F21,L"f21")
        (KEY_F22,L"f22")
        (KEY_F23,L"f23")
        (KEY_F24,L"f24")
        (KEY_NUMPAD0,L"numpad0")
        (KEY_NUMPAD1,L"numpad1")
        (KEY_NUMPAD2,L"numpad2")
        (KEY_NUMPAD3,L"numpad3")
        (KEY_NUMPAD4,L"numpad4")
        (KEY_NUMPAD5,L"numpad5")
        (KEY_NUMPAD6,L"numpad6")
        (KEY_NUMPAD7,L"numpad7")
        (KEY_NUMPAD8,L"numpad8")
        (KEY_NUMPAD9,L"numpad9")
        (KEY_LWIN,          L"lwin")
        (KEY_RWIN,          L"rwin")
        (KEY_APPS,          L"apps")
        (KEY_SLEEP,         L"sleep")
        (KEY_MBUTTON,       L"mbutton")
        (KEY_XBUTTON1,      L"xbutton1")
        (KEY_XBUTTON2,      L"xbutton2")
        (KEY_BACK,          L"back")
        (KEY_TAB,           L"tab")
        (KEY_CLEAR,         L"clear")
        (KEY_RETURN,        L"return")
        (KEY_SHIFT,         L"shift")
        (KEY_CONTROL,       L"control")
        (KEY_MENU,          L"menu")
        (KEY_PAUSE,         L"pause")
        (KEY_CAPITAL,       L"capital")
        (KEY_KANA,          L"kana")
        (KEY_HANGUEL,       L"hanguel")
        (KEY_HANGUL,        L"hangul")
        (KEY_JUNJA,         L"junja")
        (KEY_FINAL,         L"final")
        (KEY_KANJI,         L"kanji")
        (KEY_ESCAPE,        L"escape")
        (KEY_CONVERT,       L"convert")
        (KEY_NONCONVERT,    L"nonconvert")
        (KEY_ACCEPT,        L"accept")
        (KEY_MODECHANGE,    L"modechange")
        (KEY_SPACE,         L"space")
        (KEY_PRIOR,         L"prior")
        (KEY_NEXT,          L"next")
        (KEY_END,           L"end")
        (KEY_HOME,          L"home")
        (KEY_LEFT,          L"left")
        (KEY_UP,            L"up")
        (KEY_RIGHT,         L"right")
        (KEY_DOWN,          L"down")
        (KEY_SELECT,        L"select")
        (KEY_PRINT,         L"print")
        (KEY_PRINT,         L"down")
        (KEY_EXECUT,        L"execut")
        (KEY_SNAPSHOT,      L"snapshot")
        (KEY_INSERT,        L"insert")
        (KEY_DELETE,        L"delete")
        (KEY_HELP,          L"help")
        (KEY_INSERT,        L"insert")
        (KEY_MULTIPLY,      L"multiply")
        (KEY_ADD,           L"add")
        (KEY_SEPARATOR,     L"separator")
        (KEY_SUBTRACT,      L"subtract")
        (KEY_DECIMAL,       L"decimal")
        (KEY_DIVIDE,        L"divide")
        (KEY_NUMLOCK,       L"numlock")
        (KEY_SCROLL,        L"scroll")
        (KEY_LSHIFT,        L"lshift")
        (KEY_RSHIFT,        L"rshift")
        (KEY_LCONTROL,      L"lcontrol")
        (KEY_RCONTROL,      L"rcontrol")
        (KEY_LMENU,         L"lmenu")
        (KEY_RMENU,         L"rmenu")
        (KEY_PLUS,          L"plus")
        (KEY_COMMA,         L"comma")
        (KEY_MINUS,         L"minus")
        (KEY_PERIOD,        L"period")
        (KEY_ATTN,          L"attn")
        (KEY_CRSEL,         L"crsel")
        (KEY_EXSEL,         L"exsel")
        (KEY_EREOF,         L"ereof")
        (KEY_PLAY,          L"play")
        (KEY_ZOOM,          L"zoom")
        (KEY_PA1,           L"pa1")
        (KEY_OEM_CLEAR,     L"oem_clear")
        ;
//}
//catch(...)
//{
//    // TODO should be able to catch the wrong thing
////    _LOG_WARNING << "Error while initializing key bimap";
//    return false;
//}
//    return true;
}


//bool
void
initializeDeviceCodes()
{
    TDeviceCodeMap& inputDevices = CBindDescriptor::deviceCodeMap;

    boost::assign::insert(inputDevices.Bimap.left )
        (EInputType::None,          L"Unknown")
        (EInputType::MouseWheel,    L"Mou Wheel")
        (EInputType::MouseButton,   L"Mou Btn")
        (EInputType::Keyboard,      L"Key")
        (EInputType::JoystickAxis,  L"JoyAxis")
        (EInputType::JoystickButton,L"JoyButton")
        (EInputType::JoystickPov,   L"JoyPov")
;

//    inputDevices.Bimap.insert( TDeviceCodeMap::TAssociation(EInputType::None,L"Unknown"));
//    inputDevices.Bimap.insert( TDeviceCodeMap::TAssociation(EInputType::Mouse,L"Mou"));
//    inputDevices.Bimap.insert( TDeviceCodeMap::TAssociation(EInputType::Keyboard,L"Key"));
//    inputDevices.Bimap.insert( TDeviceCodeMap::TAssociation(EInputType::JoystickAxis,L"JoyAxis"));
//    inputDevices.Bimap.insert( TDeviceCodeMap::TAssociation(EInputType::JoystickButton,L"JoyButton"));
//    return true;
}
