
#ifndef _CBatteryCache_HPP
#define _CBatteryCache_HPP


#include <array>
#include <forward_list>
#include "IBatteryCache.hpp"


//EEntityType
class CBatteryCache : public IBatteryCache
{


    //typedef std::array<CIntrusiveList,EEntityType::Count> TDeadPool;

    typedef std::forward_list< IStaticBattery*> TBatteryContainer;
    TBatteryContainer _activeBatteries;

    typedef std::array< TBatteryContainer, EEntityType::Count> TDeadPool;
    TDeadPool _deadPool;

    public:

        CBatteryCache();
        ~CBatteryCache();

        void pushBattery(IStaticBattery*);


        IStaticBattery* popBattery( const EEntityType::EId&);

        std::size_t getCacheSize() { return 0;};

        void clearAll();
};


#endif
