#include "../bcCompileConfig.hpp"
#include "IGameState.hpp"
#include <fusion/logging/irrlicht_operators.hpp>
#include "../utils/debug.hpp"
#include "../game_engine.hpp"
//#include <mirrpp/IPostProcessingHandler.hpp>

#include <boost/variant.hpp>
#include <irrlicht.h>

using namespace irr;

#define VISITOR_OPERATOR(TYPE)     bool operator()( TYPE ** i) const { \
                                                return (*i != 0); \
                                                }

//! TODO utiliser des templates recursifs perso plutôt que boost::variant

class CVisitorIsLoaded : public boost::static_visitor<bool>
{
public:

//    template<typename T>

    //const
//    boost::any<>

    VISITOR_OPERATOR(irr::gui::IGUIElement);
    VISITOR_OPERATOR(irr::scene::ISceneNode);
    VISITOR_OPERATOR(irr::scene::ICameraSceneNode);
    VISITOR_OPERATOR(irr::scene::ISceneManager);
    VISITOR_OPERATOR(lua_State);


};





/**
void

**/
class unload_visitor : public boost::static_visitor<bool>
{
public:
    //const
    bool operator()(irr::gui::IGUIElement **i) const
    {
//        BOOST_ASSERT(i);

        irr::gui::IGUIElement *& element = *i;
        if(element != 0)
        {
            //!
            element->remove();
            element = 0;
        }
        return true;
    }


    bool operator()( lua_State **i) const
    {
        FUS_ASSERT(i);

//        irr::scene::ISceneNode *&node = *i;
//        //return (*i != 0);
//        removeNode(*i);
        return true;
    }
//const
    bool operator()( irr::scene::ISceneNode **i) const
    {
        FUS_ASSERT(i);

        irr::scene::ISceneNode *&node = *i;
        //return (*i != 0);
        removeNode(*i);
        return true;
    }

    void removeNode(irr::scene::ISceneNode *node) const
    {
        if( node != 0)
        {
            node->drop();
            node = 0;
        }
    }

    bool operator()( irr::scene::ICameraSceneNode **i) const
    {
        FUS_ASSERT(i);

//        (*this)( *i );
        removeNode(*i);

//        irr::scene::ISceneNode *&node = *i;
//        //return (*i != 0);
//        if( node != 0)
//        {
//            node->drop();
//            node = 0;
//        }
//        return true;
    }


    bool operator()( irr::scene::ISceneManager **i) const
    {
//        BOOST_ASSERT(i);

        irr::scene::ISceneManager *&smgr = *i;
        //return (*i != 0);
        if( smgr != 0)
        {
            smgr->drop();
            smgr = 0;
        }
        return true;
    }
};



/**
bool drawMainTab
bool useScreen
cloneSceneManager
bool displayScreenshotAsBackground
du coup le cloneScene disparaît parce qu'on ne clone que le sceneMgr de base ?
ITexture*
**/
//! const ,bool ShowCursor
// TODO remplacer les 2 par un champ de bit ou bien utiliser un enum
//enum {
//Texture
//};

IBasicGameState::IBasicGameState(
                        const std::string& name,
                        const bool& showCursor,
                        const bool& draw2d,
                        const bool& draw3d,
                        const bool& cloneScene
                        , const bool& displayScreenshotAsBackground

                        ) :
//_name(name),
//_engine( nullptr )
//,
Name(name)
, ShowCursor(showCursor)
//, AutomaticUnload(automaticUnload)
, Draw2D( draw2d )
, Draw3D( draw3d )
, CloneScene( cloneScene )
, RenderSavedScreenshot( displayScreenshotAsBackground )
// new C InputMnager
{

}




IBasicGameState::~IBasicGameState()
{
//    if(loaded()){
//        unload();
//    }
};


IGameState::IGameState(
            const std::string& name
            , const bool& showCursor
            , const bool& draw2d
            , const bool& draw3d
            , const bool& cloneScene
            , const bool& displayScreenshotAsBackground
            ) :
    IBasicGameState( name,
                showCursor,
                draw3d,
                draw3d,
                cloneScene,
                displayScreenshotAsBackground
                )
    , Scene( nullptr )
    , MainTab( nullptr )
    , _backgroundTexture(nullptr)
//    , _postProcessingHandler( 0 )
//    , SavedScreenshot(0)
{

    //


    //CGameEngine::instance().getCamera()
//    Scene( CGameEngine::instance().scene()->createNewSceneManager() )



    #ifdef DEBUG

        _INFO << "Creating GameState:\nName: " << getName()
              << "\nDraw GUI elements: " << Draw2D
              << "\nShowCursor: " << ShowCursor
              << "\nDraw 3D : " << Draw3D
              << "\nCloned smgr: " << cloneScene;
    #endif

    /////////////////////////////////////
    /////  Setup Post-processing pipeline
    /////////////////////////////////////

//    _postProcessingHandler = new EffectHandler(
//                                               engine().device()
//                                               );
    if(draw2d)
    {
        ADD_REQUIRED( MainTab , "Main tab");
    }

    if(draw3d)
    {
        ADD_REQUIRED( Scene , "Scene mgr");
        //! TODO if cloneScene, cloneScene
    }

    if( RenderSavedScreenshot )
    {
//        ADD_REQUIRED( SavedScreenshot , "Saved screenshot");
    }
}

//bool
//IGameState::load( irr::scene::ISceneManager* scene)
//{
//    //!
//    Scene = scene;
//}


bool
//IBasicGameState::load()
IGameState::load( CGameEngine* engine,irr::scene::ISceneManager* scene, irr::video::ITexture* background)
{
//    scene::ICameraSceneNode* cam = CGameEngine::instance().scene()->getActiveCamera();


//setRootSceneNode()
    _engine = engine;

    if ( (Draw3D == true) && (scene == nullptr) ){
        return false;
    }

    Scene = scene;


    if( (RenderSavedScreenshot == true) ) {
        if( (background == nullptr) )
            return false;
        else {
            _backgroundTexture = background;
            _backgroundTexture->grab();
        }
    }

//    CGameEngine::instance().scene()->createNewSceneManager(CloneScene);
//    Scene->getRootSceneNode()->setName( getName().c_str() );
//    Scene->setActiveCamera( cam );


    //CGameEngine::instance().
//    core::recti rect(0,0,0,0);
//
//    MainTab = gui()->addTab(rect,gui()->getRootGUIElement());
//    MainTab->setRelativePositionProportional ( _pos );

    //Required.push_back( Scene );

    return ( (_engine != nullptr) );
}



void
IGameState::unload()
{
    //!
//    if(Scene)
//    {
//        Scene->drop();
//    }
//loaded &=
//    unload_visitor temp();
    for(auto it(Required.begin()), last(Required.end()); it != last; ++it)
    {
        _INFO << "Unloading " << it->second;
        if ( !boost::apply_visitor( unload_visitor (), it->first ) )
        {
            _LOG_ERROR << "Could not unload";
        }
    }

}


//void
//IBasicGameState::popThisState()
//{
////this
//    getStateManager()->popState(  );
//    //engine().pushEvent(NStateEvent::PushState, NStateId::Options );
//}


bool
IGameState::isLoaded() const
{
    bool loaded = true;
    for(auto it(Required.begin()), last(Required.end()); it != last; ++it)
    {
        if(boost::apply_visitor( CVisitorIsLoaded(), it->first ) == false)
        {
            _LOG_WARNING << "Element " << it->second << " not loaded yet";
            loaded = false;
        }
    }
    return loaded;
}




//
//void IBasicGameState::onUnloadCompletion()
//{
//    _INFO << "Unload completed, dropping scene manager if exists...";
//
//    Loaded = false;
//    if(Scene != nullptr) {
//        Scene->drop();
//    }
//
//};
//


irr::scene::ISceneManager*
IGameState::scene() const
{
    return Scene;
};




irr::gui::IGUIEnvironment*
IGameState::gui() const
{
    return _engine->gui();
};


void
IGameState::showWireframe(const bool&)
{
    // TODO paroucrir materials et mettre wireframe to true
}



//EffectHandler*
IPostProcessingHandler*
IGameState::pp()
{
    // PostProcessingFramework()
    return engine().getPostProcessing();
    //_postProcessingEffect;
};
//


irr::video::IVideoDriver* IGameState::driver() const {
    return _engine->driver();
}


// TODO a remplacer par un copyBackBuffer
//void
//IGameState::takeScreenshot(irr::video::ITexture* rt)
//{
//
//
////	if( !driver()->beginScene(true, true,0) ){
////        _LOG_ERROR << "could not start drawing scene";
////	}
//
//
//    //0xffffffff
//    //video::SColor(255,0,0,255)
//    if (! driver()->setRenderTarget(rt, true, true, video::SColor(0,255,255,255) ) )
//    {
//
//        _LOG_ERROR << "Could not set rtt" ;
//        //driver()->
//    }
////    driver()->setMaterial()
//
//    scene()->drawAll();
//
////            ! Save it to a file
//            video::IImage* img = driver()->createImage( rt, core::vector2di(), rt->getSize());
//            driver()->writeImageToFile(img, "Test.png");
//            img->drop();
//
//
////    if( !driver()->endScene() ){
////        _LOG_ERROR << "could not end scene";
////    }
//}

